(ns rss-tumblr.core
  (:require [crouton.html :as html]
            [clojure.xml :as xml]))

(comment  (html/parse "https://tumblr.com"))

(defn getFeeds
  [opml-file]
  (-> (xml/parse opml-file)
     ; Get the RSS feeds
      (get-in [:content])
      (second)
      (get-in [:content])))

(->> (getFeeds "resources/NewsFlash.OPML")
     ; Get aesthetic tag
     (filterv #(= (get-in % [:attrs :text]) "aesthetic"))
     ; get the feed list
     (first)
     (:content)
     ; only tumblr posts
     (filterv #(.contains (get-in % [:attrs :xmlUrl]) "tumblr"))
     ; take a specific feed
     (second)
     ; TODO ugly, use get-in or something
     ; get the rss feed url
     (:attrs)
     (:xmlUrl)
     ; grab content from the feed
     (html/parse)
     ; get the vector of posts
     (:content)
     (filterv #(not (nil? (% :content))))
     ; RSS is weird...
     ; I should probably use a library for this 
     (first)
     (:content)
     (first)
     (:content)
     (first)
     (:content)
     ; -- vector of posts achieved
     ; we only care about :tag "item"
     )
